﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Principal;
using Microsoft.Practices.EnterpriseLibrary.Security;


namespace HRService
{
    class Auth_AzMan_EntLib
        : IAuthProvider
    {
       



        #region IAuthProvider Members

        public void ApplyPermissions(HRServiceBus.Context ctx)
        {
            IIdentity user = ctx.User;
            IPrincipal p = new WindowsPrincipal((WindowsIdentity) user);

            IAuthorizationProvider auth = AuthorizationFactory.GetAuthorizationProvider("HRDemo");
                                                            
            ctx.Rights = new HRServiceEntities.Rights();

            ctx.Rights.AddEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.AddEmployee);
            ctx.Rights.GetEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployee);
            ctx.Rights.GetEmployeeAddress = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeAddress);
            ctx.Rights.GetEmployeeBonus = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeBonus);
            ctx.Rights.GetEmployeeSalary = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeSalary);
            ctx.Rights.GetEmployeeSSN = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeSSN);
            ctx.Rights.ListEmployees = auth.Authorize(p, "O:" + HRServiceBus.Operations.ListEmployees);
            ctx.Rights.ReinstateEmployees = auth.Authorize(p, "O:" + HRServiceBus.Operations.ReinstateEmployee);
            ctx.Rights.SetEmployeeAddress = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeAddress);
            ctx.Rights.SetEmployeeManager = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeManager);
            ctx.Rights.SetEmployeePosition = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeePosition);
            ctx.Rights.SetEmployeeSalary = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeSalary);
            ctx.Rights.SetEmployeeSSN = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeSSN);
            ctx.Rights.TerminateEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.TerminateEmployee);
            ctx.Rights.UpdateEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.UpdateEmployee);


            // -------------------------------------------------------------------
            // Get rights for Self
            // -------------------------------------------------------------------

            auth = AuthorizationFactory.GetAuthorizationProvider("HRDemo.Self");

            ctx.RightsToSelf = new HRServiceEntities.Rights();

            ctx.RightsToSelf.AddEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.AddEmployee);
            ctx.RightsToSelf.GetEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployee);
            ctx.RightsToSelf.GetEmployeeAddress = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeAddress);
            ctx.RightsToSelf.GetEmployeeBonus = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeBonus);
            ctx.RightsToSelf.GetEmployeeSalary = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeSalary);
            ctx.RightsToSelf.GetEmployeeSSN = auth.Authorize(p, "O:" + HRServiceBus.Operations.GetEmployeeSSN);
            ctx.RightsToSelf.ListEmployees = auth.Authorize(p, "O:" + HRServiceBus.Operations.ListEmployees);
            ctx.RightsToSelf.ReinstateEmployees = auth.Authorize(p, "O:" + HRServiceBus.Operations.ReinstateEmployee);
            ctx.RightsToSelf.SetEmployeeAddress = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeAddress);
            ctx.RightsToSelf.SetEmployeeManager = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeManager);
            ctx.RightsToSelf.SetEmployeePosition = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeePosition);
            ctx.RightsToSelf.SetEmployeeSalary = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeSalary);
            ctx.RightsToSelf.SetEmployeeSSN = auth.Authorize(p, "O:" + HRServiceBus.Operations.SetEmployeeSSN);
            ctx.RightsToSelf.TerminateEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.TerminateEmployee);
            ctx.RightsToSelf.UpdateEmployee = auth.Authorize(p, "O:" + HRServiceBus.Operations.UpdateEmployee);
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            return;
        }

        #endregion
    }
}
