﻿using System;

namespace HRService
{
    /// <summary>
    /// Defines the methods that the system requires populate the properties
    /// on the Rights class.
    /// </summary>
    /// <remarks>
    /// Different implementations pull the info from different places. 
    /// Some pull from AzMan, others from EntLib, others are hard coded.
    /// </remarks>
    interface IAuthProvider
        : IDisposable
    {

        /// <summary>
        /// Use the identity on the Context class to set the 
        /// values on the Rights and RightsToSelf properties.
        /// </summary>
        /// <param name="ctx">The context object, containing the user identity and rights.</param>
        void ApplyPermissions(HRServiceBus.Context ctx);
    
    }
}
