﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Principal;
using HRServiceEntities;

namespace HRServiceBus
{

    /// <summary>
    /// The Context class holds the current user's identity and the permissions that they have.
    /// It is passed between the service layer and business layer so that both layers have access
    /// to the user and permissions for authorization checks.
    /// </summary>
    public class Context
    {

        public Context(IIdentity user)
        {
            this.User = user;
        }

        /// <summary>
        /// The identity of the user.
        /// </summary>
        public IIdentity User { get; set; }

        /// <summary>
        /// Permissons that the user has to all employee records.
        /// </summary>
        public Rights Rights { get; set; }

        /// <summary>
        /// Permissions that the user has to their own employee record.
        /// </summary>
        public Rights RightsToSelf { get; set; }

    }
}
