﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HRServiceEntities
{

    /// <summary>
    /// Used when updating an employee.
    /// </summary>
    /// <remarks>
    /// Contains the employee fields, plus a corresponding "UpdateXXX" field.
    /// The system will only change fields where the UpdateXXX property is true.
    /// </remarks>
    [DataContract()]
    public class EmployeeUpdateInfo 
        : Employee
    {

        [DataMember()]
        public bool UpdateUsername { get; set; }

        [DataMember()]
        public bool UpdateFirstName { get; set; }

        [DataMember()]
        public bool UpdateLastName { get; set; }


        [DataMember()]
        public bool UpdateHomeAddress { get; set; }


        [DataMember()]
        public bool UpdatePosition { get; set; }

        [DataMember()]
        public bool UpdateManagerID { get; set; }


        [DataMember()]
        public bool UpdateSSN { get; set; }

        [DataMember()]
        public bool UpdateSalary { get; set; }

        [DataMember()]
        public bool UpdateBonusPercentage { get; set; }

    }
}
