﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HRServiceEntities
{

    /// <summary>
    /// The Rights class indicates whether the user has permission to
    /// each of the application's "operations". The properties here
    /// match the operations defined in the AzMan policy store.
    /// </summary>
    /// <remarks>
    /// This has been created as a DataContact so that the rights can be
    /// fetched by the UI layer via the web service. This is not required
    /// in all applications, but is used in this demo to allow the UI to 
    /// be permission aware.
    /// </remarks>
    [DataContract()]
    public class Rights
    {
        [DataMember()]
        public bool ListEmployees;

        [DataMember()]
        public bool AddEmployee;

        [DataMember()]
        public bool GetEmployee;
        [DataMember()]
        public bool GetEmployeeAddress;
        [DataMember()]
        public bool GetEmployeeBonus;
        [DataMember()]
        public bool GetEmployeeSalary;
        [DataMember()]
        public bool GetEmployeeSSN;

        [DataMember()]
        public bool UpdateEmployee;
        [DataMember()]
        public bool SetEmployeeAddress;
        [DataMember()]
        public bool SetEmployeeSSN;
        [DataMember()]
        public bool SetEmployeeSalary;
        [DataMember()]
        public bool SetEmployeeManager;
        [DataMember()]
        public bool SetEmployeePosition;

        [DataMember()]
        public bool TerminateEmployee;
        [DataMember()]
        public bool ReinstateEmployees;

    }
}
