﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using Microsoft.Interop.Security.AzRoles;

namespace HRPrincipalLocator
{

    [Guid("71EF2BDB-7F1F-4eed-8908-F0546BDA7136")]
    public class DemoNameResolver
        : IAzNameResolver
    {

        #region IAzNameResolver Members

        public string NameFromSid(string bstrSid, out int pSidType)
        {
            pSidType = (int)SID_NAME_USE.SidTypeUser;
            return bstrSid;
        }

        public object NamesFromSids(object vSids, out object pvSidTypes)
        {
            object[] sids = (object[])vSids;
            List<object> ret = new List<object>();
            List<object> retTypes = new List<object>();
            
            foreach (object sid in sids)
            {
                int sidType = 0;
                string name = this.NameFromSid((string)sid, out sidType);

                ret.Add(name);
                retTypes.Add(sidType);
            }

            pvSidTypes = retTypes.ToArray();
            return ret.ToArray();
        }

        #endregion

    }
}
