﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using Microsoft.Interop.Security.AzRoles;
using System.Windows.Forms;

namespace HRPrincipalLocator
{

    [ComVisible(false)]
    public enum SID_NAME_USE
    {
        SidTypeUser = 1,
        SidTypeGroup,
        SidTypeDomain,
        SidTypeAlias,
        SidTypeWellKnownGroup,
        SidTypeDeletedAccount,
        SidTypeInvalid,
        SidTypeUnknown,
        SidTypeComputer,
        SidTypeLabel
    }

    [ComVisible(false)]
    public static class SidTypes
    {

        public static SID_NAME_USE[] GetSidTypes()
        {
            SID_NAME_USE[] ret = {
                SID_NAME_USE.SidTypeUser, 
                SID_NAME_USE.SidTypeComputer, 
                SID_NAME_USE.SidTypeDeletedAccount, 
                SID_NAME_USE.SidTypeDomain, 
                SID_NAME_USE.SidTypeGroup, 
                SID_NAME_USE.SidTypeInvalid, 
                SID_NAME_USE.SidTypeLabel, 
                SID_NAME_USE.SidTypeUnknown, 
                SID_NAME_USE.SidTypeUser, 
                SID_NAME_USE.SidTypeWellKnownGroup
            };

            return ret;
        }
    }


    [ComVisible(false)]
    public class ExternalWindowHandle 
        : IWin32Window
    {

        private IntPtr _handle;


        public ExternalWindowHandle(IntPtr handle)
        {
            _handle = handle;
        }

        #region IWin32Window Members

        public IntPtr Handle
        {
            get {
                return _handle;
            }
        }

        #endregion
    }


    [Guid("065524F5-77D0-47c6-AA7C-3745A574F929")]
    public class DemoObjectPicker
        : IAzObjectPicker
    {

        #region IAzObjectPicker Members

        public object GetPrincipals(ref _RemotableHandle hParentWnd, string bstrTitle, out object pvSidTypes, out object pvNames)
        {
            using (DemoPicker picker = new DemoPicker())
            {
                DialogResult result = picker.ShowDialog(new ExternalWindowHandle(new IntPtr(hParentWnd.u.hInproc)));

                object[] sidTypes = { picker.SidType };
                object[] names = { picker.SidName };
                object[] sids = { picker.SidValue };

                pvSidTypes = sidTypes;
                pvNames = names;

                return sids;
            }
        }

        public string Name
        {
            get
            {
                return "Demo Object Picker";
            }
        }

        #endregion

    }
}
